]> git.pld-linux.org Git - packages/rpm.git/blobdiff - rpm.macros
- added _npkgconfigdir (noarch version of _pkgconfigdir)
[packages/rpm.git] / rpm.macros
index a54525c9e79447762817ba136702fe28cbd3873d..1659f18c3015b28feecc6a45d052d1ec6438ab74 100644 (file)
@@ -8,6 +8,8 @@
 %kgcc          %{__cc}
 %kgcc_package  gcc
 
+%__rm                  /bin/rm --interactive=never
+
 # Build system path macros.
 #
 %__autoconf            autoconf %{?debug:-Wall}
@@ -15,7 +17,6 @@
 %__autopoint           autopoint --force
 
 %__gettextize { \
-if ! gettextize --version | grep -q '0\.10\.' ; then \
        if grep -qs 'AM_GNU_GETTEXT.*external' configure.{ac,in} ; then \
                gettextize --copy --force --no-changelog; \
        else \
@@ -24,9 +25,6 @@ if ! gettextize --version | grep -q '0\.10\.' ; then \
        if [ ! -f po/Makevars ]; then \
                cp -f po/Makevars{.template,}; \
        fi; \
-else \
-       gettextize --copy --force; \
-fi; \
 }
 
 %__glib_gettextize     glib-gettextize --copy --force
@@ -36,6 +34,9 @@ fi; \
 %__intltoolize         intltoolize --copy --force
 %__libtoolize          libtoolize --copy --force
 
+#      Path to top of build area.
+%_topdir               %{expand:%%global _topdir %(test -d ../SPECS -a -d ../SOURCES && (cd ..; pwd) || echo $HOME/rpm)}%_topdir
+
 #      The number of cvs changelog entries kept when building package.
 %_buildchangelogtruncate 20
 
@@ -51,11 +52,15 @@ fi; \
 #      and that both p and q are package names (i.e. no version/release).
 %_dependency_whiteout  %{nil}
 
+%_smp_mflags %([ -z "$RPM_BUILD_NCPUS" ] \\\
+       && RPM_BUILD_NCPUS="`/usr/bin/getconf _NPROCESSORS_ONLN`"; \\\
+       [ "$RPM_BUILD_NCPUS" -gt 1 ] && echo "-j$RPM_BUILD_NCPUS")
 
 #-----------------------------------------------------------------
 #
 # (re)definition of %{rpm*flags} with %filterout_* support
-# Requires:            awk
+# BuildRequires:       awk
+# BuildRequires:       rpmbuild(macros) >= 1.315
 #
 # Flags specified in %filterout_* are removed from %rpm*flags, exactly:
 # %rpmcflags    = %optflags - %filterout - %filterout_c   - %filterout_ld
@@ -66,7 +71,7 @@ fi; \
 # as regular expression it must be escaped twice.
 
 %filter_out                                            \
-       for (i in I) {  A=0;                    \
+       for (i = 1; i in I; i++) {      A=0;    \
                for (f in F) {                          \
                        if (I[i] ~ "^" F[f] "$") A=1;   \
                };                                                      \
@@ -112,6 +117,7 @@ fi; \
  CFLAGS="${CFLAGS:-%rpmcflags}" ; export CFLAGS ; \
  CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" ; export CXXFLAGS ; \
  FFLAGS="${FFLAGS:-%rpmcflags}" ; export FFLAGS ; \
+ FCFLAGS="${FCFLAGS:-%rpmcflags}" ; export FCFLAGS ; \
  CPPFLAGS="${CPPFLAGS:-}" ; export CPPFLAGS ; \
  %{?__cc:CC="%{__cc}" ; export CC ; } \
  %{?__cxx:CXX="%{__cxx}" ; export CXX ; } \
@@ -148,6 +154,15 @@ CXXFLAGS="%{rpmcxxflags}" \
 %__scons       /usr/bin/scons
 %scons { \
 %{__scons} \
+       LDFLAGS="${LDFLAGS:-%rpmldflags}" \
+       CFLAGS="${CFLAGS:-%rpmcflags}" \
+       CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
+       FFLAGS="${FFLAGS:-%rpmcflags}" \
+       CPPFLAGS="${CPPFLAGS:-}" \
+       %{?__cc:CC="%{__cc}"} \
+       %{?__cxx:CXX="%{__cxx}"} \
+       libsuffix=%{_lib} \
+       prefix=%{_prefix} \
 }
 
 # waf. see waf.spec
@@ -163,7 +178,7 @@ CXXFLAGS="%{rpmcxxflags}" \
 }
 
 #----------------------------------------------------------------
-%global configure_cache 0
+#%configure_cache 0
 %configure_cache_file  %{buildroot}.configure.cache
 
 %configure {./configure \
@@ -171,6 +186,7 @@ CXXFLAGS="%{rpmcxxflags}" \
        CFLAGS="${CFLAGS:-%rpmcflags}" \
        CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
        FFLAGS="${FFLAGS:-%rpmcflags}" \
+       FCFLAGS="${FCFLAGS:-%rpmcflags}" \
        CPPFLAGS="${CPPFLAGS:-}" \
        %{?__cc:CC="%{__cc}"} \
        %{?__cxx:CXX="%{__cxx}"} \
@@ -191,51 +207,27 @@ CXXFLAGS="%{rpmcxxflags}" \
        --infodir=%{_infodir} \
        --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
        %{dependencytracking} \
-       %{?configure_cache:--cache-file=%{configure_cache_file:-%{buildroot}.configure.cache}} \
+       %{?configure_cache:--cache-file=%{configure_cache_file}} \
 }
 
-# ------------------------------------------------------------------------
-# Overloading of some basic macros
+# overload to insert debuginfo package
 %prep \
-%%prep\
-export LC_ALL=C\
-export LANG=C\
-unset LINGUAS ||:\
-unset LANGUAGE ||:\
-unset LC_MESSAGES ||:\
-unset DISPLAY ||:\
-%{nil}
-
-%build %%build\
-export LC_ALL=C\
-export LANG=C\
-unset LINGUAS ||:\
-unset LANGUAGE ||:\
-unset LC_MESSAGES ||:\
-unset DISPLAY ||:\
-%{nil}
-
-%install \
 %if 0%{?_enable_debug_packages}\
-%{?buildsubdir:%{debug_package}}\
+%{debug_package}\
 %endif\
-%%install\
-export LC_ALL=C\
-export LANG=C\
-unset LINGUAS ||:\
-unset LANGUAGE ||:\
-unset LC_MESSAGES ||:\
-unset DISPLAY ||:\
+%%prep\
 %{nil}
 
 # Location of autoconf macros
-%_aclocaldir   %(aclocal --print-ac-dir)
+%_aclocaldir   %{expand:%%global _aclocaldir %(aclocal --print-ac-dir || echo ERROR)}%_aclocaldir
 
 # Location of omf files
-%_omf_dest_dir %(scrollkeeper-config --omfdir)
+%_omf_dest_dir %{expand:%%global _omf_dest_dir %(scrollkeeper-config --omfdir || echo ERROR)}%_omf_dest_dir
 
 # Location of pkgconfig files
 %_pkgconfigdir /usr/%{_lib}/pkgconfig
+# noarch pkgconfig files
+%_npkgconfigdir        /usr/share/pkgconfig
 
 # Location of desktop files
 %_desktopdir   /usr/share/applications
@@ -262,9 +254,6 @@ unset DISPLAY ||:\
 # Current date
 %date          %(LC_ALL="C" date +"%a %b %d %Y")
 
-# tmp directory
-%tmpdir                %(echo "${TMPDIR:-/tmp}")
-
 # Example files, programs, scripts...
 %_examplesdir  /usr/src/examples
 
@@ -278,24 +267,27 @@ unset DISPLAY ||:\
 %_rpmfilename          %%{NAME}-%%{VERSION}-%%{RELEASE}%{?debug:dbg}.%%{ARCH}.rpm
 
 # Requires name = version-release
-%requires_releq()              %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %%{name} = %%{epoch}:%%{version}-%%{release}\\n' | sed -e 's/ (none):/ /' | grep -v "is not")
+%requires_releq()              %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %{N} = %|E?{%{E}:}|%{V}-%{R}\\n' | grep -v 'is not')
 
-%releq_kernel_up()             %((LC_ALL="C" rpm -qf --qf '%%{name}-up = %%{epoch}:%%{version}-%%{release}\\n' %{_kernelsrcdir}/include/linux/version.h 2>/dev/null || echo ERROR) | sed -e 's/ (none):/ /' | sed -e 's:-headers::' | grep -vE "(is not|no such)")
-%releq_kernel_smp()            %((LC_ALL="C" rpm -qf --qf '%%{name}-smp = %%{epoch}:%%{version}-%%{release}\\n' %{_kernelsrcdir}/include/linux/version.h 2>/dev/null || echo ERROR) | sed -e 's/ (none):/ /' | sed -e 's:-headers::' | grep -vE "(is not|no such)")
+%releq_kernel                  %{expand:%%global releq_kernel %(R=$(LC_ALL=C rpm -q --qf '%{N} = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel
+%releq_kernel_up               %{expand:%%global releq_kernel_up %(R=$(LC_ALL=C rpm -q --qf '%{N}-up = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_up
+%releq_kernel_smp()            %{expand:%%global releq_kernel_smp %(R=$(LC_ALL=C rpm -q --qf '%{N}-smp = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_smp
+%requires_releq_kernel(s:)             Requires%{-s:(%{-s*})}: %releq_kernel
 %requires_releq_kernel_up(s:)  Requires%{-s:(%{-s*})}: %releq_kernel_up
 %requires_releq_kernel_smp(s:) Requires%{-s:(%{-s*})}: %releq_kernel_smp
 
-%requires_eq()         %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %%{name} = %%{epoch}:%%{version}\\n' | sed -e 's/ (none):/ /' -e 's/ 0:/ /' | grep -v "is not")
-%requires_eq_to() %(LC_ALL="C" rpm -q --qf 'Requires: %1 = %%{epoch}:%%{version}\\n' %2 | sed -e 's/ (none):/ /' | grep -v "is not")
+# XXX: why epoch 0 is stripped?
+%requires_eq()         %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %{N} = %|E?{%{E}:}|%{V}\\n' | sed -e 's/ 0:/ /' | grep -v 'is not')
+%requires_eq_to() %(LC_ALL="C" rpm -q --qf 'Requires: %1 = %|E?{%{E}:}|%{V}' %2 | grep -v "is not")
 
-%apache_modules_api %(awk '/#define MODULE_MAGIC_NUMBER_MAJOR/ {print $3}' /usr/include/apache/ap_mmn.h 2>/dev/null || echo ERROR)
+%apache_modules_api %{expand:%%global apache_modules_api %(awk '/#define MODULE_MAGIC_NUMBER_MAJOR/ {print $3}' /usr/include/apache/ap_mmn.h 2>/dev/null || echo ERROR)}%apache_modules_api
 
 # kernel version-release handling
-%__kernel_ver  %( VER_H=%{_kernelsrcdir}/include/linux/utsrelease.h; [ -f $VER_H ] || VER_H=%{_kernelsrcdir}/include/linux/version.h; [ -f $VER_H ] && (grep UTS_RELEASE $VER_H 2>/dev/null | head -n 1 | cut -d'"' -f2) || (awk '/^VERSION/ { ver = $0; gsub(/VERSION.*=/, NIL, ver); } /^PATCHLEVEL/ { plev = $0; gsub(/PATCHLEVEL.*=/, NIL, plev); } /^SUBLEVEL/ { slev = $0; gsub(/SUBLEVEL.*=/, NIL, slev); } /^EXTRAVERSION/ { ever = $0; gsub(/EXTRAVERSION.*=/, NIL, ever); gsub(/ /, NIL, ever); } END { printf("%d.%d.%d%s", ver, plev, slev, ever); }' %{_kernelsrcdir}/Makefile 2> /dev/null))
-%__kernel_rel  %(LC_ALL="C" rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{RELEASE}" | grep -v "is not")
-%__kernel_rpmvr        %(LC_ALL="C" rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{VERSION}-%{RELEASE}" | grep -v "is not")
-%_kernel_ver   %{__kernel_ver}%{?with_dist_kernel:%(echo %{__kernel_ver} | grep -q -e - || echo -%{__kernel_rel})}
-%_kernel_ver_str %(echo %{!?_without_dist_kernel:%{__kernel_rpmvr}}%{?_without_dist_kernel:%{__kernel_ver}} | sed -e 's/-/_/g')
+%__kernel_ver   %{expand:%%global __kernel_ver %(VER_H=%{_kernelsrcdir}/include/linux/utsrelease.h; [ -f $VER_H ] || VER_H=%{_kernelsrcdir}/include/linux/version.h; [ -f $VER_H ] && (grep UTS_RELEASE $VER_H 2>/dev/null | head -n 1 | cut -d'"' -f2) || (awk '/^VERSION/ { ver = $0; gsub(/VERSION.*=/, NIL, ver); } /^PATCHLEVEL/ { plev = $0; gsub(/PATCHLEVEL.*=/, NIL, plev); } /^SUBLEVEL/ { slev = $0; gsub(/SUBLEVEL.*=/, NIL, slev); } /^EXTRAVERSION/ { ever = $0; gsub(/EXTRAVERSION.*=/, NIL, ever); gsub(/ /, NIL, ever); } END { printf("%d.%d.%d%s", ver, plev, slev, ever); }' %{_kernelsrcdir}/Makefile 2> /dev/null))}%__kernel_ver
+%__kernel_rel  %{expand:%%global __kernel_rel %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rel
+%__kernel_rpmvr        %{expand:%%global __kernel_rpmvr %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{V}-%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rpmvr
+%_kernel_ver   %{expand:%%global _kernel_ver %{__kernel_ver}%{?with_dist_kernel:%(echo %{__kernel_ver} | grep -q -e - || echo -%{__kernel_rel})}}%_kernel_ver
+%_kernel_ver_str %{expand:%%global _kernel_ver_str %(echo %{!?_without_dist_kernel:%{__kernel_rpmvr}}%{?_without_dist_kernel:%{__kernel_ver}} | sed -e 's/-/_/g')}%_kernel_ver_str
 
 # sgml macros
 %xmlcat_add()          /usr/bin/xmlcatalog --noout --add nextCatalog \"\" %1 /etc/xml/catalog ;
@@ -315,6 +307,8 @@ unset DISPLAY ||:\
 ; do echo $l; done >> %1 \
 }
 
+# vim - "
+
 # minimum file size needed for compressed documents.
 # just smaller files than this get larger when compressed.
 # some stats:
@@ -331,14 +325,26 @@ unset DISPLAY ||:\
 #%no_install_post_compress_docs        1
 %__spec_install_post_compress_docs { \
 %{!?no_install_post_compress_docs:__spec_install_post_compress_docs() { \
-       for i in /usr/share/man /usr/X11R6/man /usr/share/info; do \
+       for i in /usr/share/man /usr/X11R6/man; do \
                if [ -d "$RPM_BUILD_ROOT$i" ]; then \
-                       echo "Compress $(basename $i) pages: $i"; \
+                       echo "Compress man pages: $i"; \
                        find "$RPM_BUILD_ROOT$i" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
                        find "$RPM_BUILD_ROOT$i" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
+                       find $RPM_BUILD_ROOT$i -type l | while read a; do \
+                               m=$(readlink $a); \
+                               rm -f $a; \
+                               echo .so ${m##*/} > $a; \
+                               echo >&2 "Converted ${a#$RPM_BUILD_ROOT} from symlink to man link: ${m##*/}"; \
+                       done; \
                        find "$RPM_BUILD_ROOT$i" -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
                fi; \
        done; \
+       if [ -d "$RPM_BUILD_ROOT%{_infodir}" ]; then \
+               echo "Compress info pages: %{_infodir}"; \
+               find "$RPM_BUILD_ROOT%{_infodir}" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
+               find "$RPM_BUILD_ROOT%{_infodir}" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
+               find "$RPM_BUILD_ROOT%{_infodir}" -name '*.info*' -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
+       fi; \
 }; __spec_install_post_compress_docs } }
 
 #-----------------------------------------------------------------
@@ -346,34 +352,70 @@ unset DISPLAY ||:\
 #
 # Requires: find, awk, strip, cut, xargs
 #
-#%no_install_post_strip        1
+# Special macros which affect this process:
+#%no_install_post_strip        1               # disable stripping at all
+#%_noautostrip                 regexp  # exclude files matching (anchored!) regex from stripping
+#%_autostripall                        regexp  # strip files matching (anchored!) regex using plain strip
+#%_autostripunneeded   regexp  # strip files matching (anchored!) regex using strip --strip-unneeded
+#%_autostripdebug              regexp  # strip files matching (anchored!) regex using strip --strip-debug
+#
 %__spec_install_post_strip {%{!?debug: \
 %{!?no_install_post_strip:__spec_install_post_strip() { \
 if [ -d "$RPM_BUILD_ROOT" ]; then \
-       filelist=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*\.debug" %{?_noautostrip:! -regex "%{_noautostrip}"}`; \
-       if [ -z "$filelist" ]; then \
-               return; \
+       if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
+               modulelist=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
+               if [ "$modulelist" ]; then \
+                       modulecount=$(echo "$modulelist" | wc -l); \
+                       printf "Stripping %d kernel modules..." $modulecount; \
+                       echo "$modulelist" | xargs -l512 chmod u+w; \
+                       echo "$modulelist" | xargs -l512 %{__strip} --strip-unneeded --remove-section=.comment --remove-section=.note.GNU-stack; \
+                       echo "DONE"; \
+               fi; \
+       fi; \
+       filelist=$(find $RPM_BUILD_ROOT -type f ! -regex ".*/usr/lib[0-9]*/debug/.*\.debug" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautostrip:! -regex "%{_noautostrip}"} %{?_autostripall:! -regex "%{_autostripall}"} %{?_autostripunneeded:! -regex "%{_autostripunneeded}"} %{?_autostripdebug:! -regex "%{_autostripdebug}"}); \
+       if [ -n "$filelist" ]; then \
+               filetypes=`echo "$filelist" | xargs -r -d'\\n' file`; \
+               elfexelist=`echo "$filetypes" | awk -F: '/ELF.*executable/ {print $1}'`; \
+               elfsharedlist=`echo "$filetypes" | awk -F: '/LF.*shared object/ {print $1}'`; \
+               archiveslist=`echo "$filetypes" | awk -F: '/current ar archive/ {print $1}'`; \
+               if [ -n "$elfexelist" ]; then \
+                       printf "Stripping %d ELF executables..." $(echo "$elfexelist" | wc -l); \
+                       chmod u+w $elfexelist; \
+                       %{__strip} --remove-section=.note --remove-section=.comment $elfexelist; \
+                       echo "DONE"; \
+               fi; \
+               if [ -n "$elfsharedlist" ]; then \
+                       printf "Stripping %d ELF shared libraries..." $(echo "$elfsharedlist" | wc -l); \
+                       chmod u+w $elfsharedlist; \
+                       %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $elfsharedlist; \
+                       echo "DONE"; \
+               fi; \
+               if [ -n "$archiveslist" ]; then \
+                       printf "Stripping %d ar archives..." $(echo "$archiveslist" | wc -l); \
+                       chmod u+w $archiveslist; \
+                       %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $archiveslist; \
+                       echo "DONE"; \
+               fi; \
        fi; \
-       filetypes=`echo $filelist | xargs -r file`; \
-       elfexelist=`echo "$filetypes" | awk '/ELF.*executable/ {print $1}' | cut -d: -f1`; \
-       elfsharedlist=`echo "$filetypes" | awk '/LF.*shared object/ {print $1}' | cut -d: -f1`; \
-       archiveslist=`echo "$filetypes" | awk '/current ar archive/ {print $1}' | cut -d: -f1`; \
-       if [ -n "$elfexelist" ]; then \
-               printf "Stripping %d ELF executables..." $(echo "$elfexelist" | wc -l); \
-               chmod u+w $elfexelist; \
-               %{__strip} --remove-section=.note --remove-section=.comment $elfexelist; \
+    filelist_all=%{?_autostripall:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripall}")}; \
+    filelist_unneeded=%{?_autostripunneeded:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripunneeded}")}; \
+    filelist_debug=%{?_autostripdebug:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripdebug}")}; \
+       if [ -n "$filelist_all" ]; then \
+               printf "Stripping everything from %d additional files..." $(echo "$filelist_all" | wc -l); \
+               chmod u+w $filelist_all; \
+               %{__strip} --remove-section=.note --remove-section=.comment $filelist_all; \
                echo "DONE"; \
        fi; \
-       if [ -n "$elfsharedlist" ]; then \
-               printf "Stripping %d ELF shared libraries..." $(echo "$elfsharedlist" | wc -l); \
-               chmod u+w $elfsharedlist; \
-               %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $elfsharedlist; \
+       if [ -n "$filelist_unneeded" ]; then \
+               printf "Stripping unneeded from %d additional files..." $(echo "$filelist_unneeded" | wc -l); \
+               chmod u+w $filelist_unneeded; \
+               %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $filelist_unneeded; \
                echo "DONE"; \
        fi; \
-       if [ -n "$archiveslist" ]; then \
-               printf "Stripping %d ar archives..." $(echo "$elfsharedlist" | wc -l); \
-               chmod u+w $archiveslist; \
-               %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $archiveslist; \
+       if [ -n "$filelist_debug" ]; then \
+               printf "Stripping debuginfo from %d additional files..." $(echo "$filelist_debug" | wc -l); \
+               chmod u+w $filelist_debug; \
+               %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $filelist_debug; \
                echo "DONE"; \
        fi; \
 fi; }; __spec_install_post_strip } } }
@@ -383,15 +425,17 @@ fi; }; __spec_install_post_strip } } }
 #
 # Requires: find, awk, cut, xargs, chrpath, uname
 #
-#%no_install_post_chrpath      1
+# Special macros which affect this process
+#%no_install_post_chrpath      1       # disable chrpath at all
+#%_noautochrpath       regex           # exclude files matching (anchored!) regex from chrpath
+#
 %__spec_install_post_chrpath {%{!?debug: \
 %{!?no_install_post_chrpath: __spec_install_post_chrpath() { \
 if [ -d "$RPM_BUILD_ROOT" ]; then \
-       files=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*" %{?_noautochrpath:! -regex "%{_noautochrpath}"}`; \
+       files=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautochrpath:! -regex "%{_noautochrpath}"}`; \
        if [ -n "$files" ]; then \
-               objs=`echo "$files" | xargs -r file | awk '/ELF.*(executable.*dynamically linked|shared object)/ {print $1}' | cut -d: -f1`; \
-       fi
-       #"
+               objs=`echo "$files" | xargs -r -d'\\n' file | awk -F: '/ELF.*(executable.*dynamically linked|shared object)/ {print $1}'`; \
+       fi; \
        if [ -n "$objs" ]; then \
                printf "Remove RPATH from %d executable binaries and shared object files.\n" $(echo "$objs" | wc -l); \
                echo "$objs" | \
@@ -425,12 +469,14 @@ fi; }; __spec_install_post_chrpath } } }
 %__spec_install_post_compress_modules { \
 %{!?no_install_post_compress_modules: __spec_install_post_compress_modules() { \
        if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
-               echo "Compress kernel modules"; \
                q=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
-               echo "$q" | xargs -r %{__gzip} -9nf; \
-               printf "%d modules compressed\n" $(echo "$q" | wc -l); \
-               find $RPM_BUILD_ROOT/lib/modules -name '*o' -type l -printf "%p %l\n" | \
-               while read a b; do ln -sf $b.gz $a.gz; rm -f $a; done; \
+               if [ "$q" ]; then \
+                       printf "Compress %d kernel modules..." $(echo "$q" | wc -l); \
+                       echo "$q" | xargs -r %{__gzip} -9nf; \
+                       echo "DONE"; \
+                       find $RPM_BUILD_ROOT/lib/modules -name '*o' -type l -printf "%p %l\n" | \
+                       while read a b; do ln -sf $b.gz $a.gz; rm -f $a; done; \
+               fi; \
        fi; \
 }; __spec_install_post_compress_modules } }
 
@@ -447,31 +493,31 @@ fi; }; __spec_install_post_chrpath } } }
 #
 %gconf_schema_install() \
        umask 022; \
-       GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" /usr/bin/gconftool-2 --makefile-install-rule /etc/gconf/schemas/%{?1}%{!?1:*.schemas} > /dev/null \
-       %{nil}
+       GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" /usr/bin/gconftool-2 --makefile-install-rule /etc/gconf/schemas/%{?1}%{!?1:*.schemas} > /dev/null; \
+%{nil}
 
 %gconf_schema_uninstall() \
 if [ $1 = 0 ]; then \
        umask 022; \
        GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" /usr/bin/gconftool-2 --makefile-uninstall-rule /etc/gconf/schemas/%{?1} > /dev/null \
-fi \
+fi; \
 %{nil}
 
 #-----------------------------------------------------------------
 # Update desktop MIME database
 # requires: desktop-file-utils
-#
-%update_desktop_database_post() {{ \
+%update_desktop_database() {{ \
        umask 022; \
        /usr/bin/update-desktop-database -q; \
-}}
+}}%{nil}
+
+%update_desktop_database_post %update_desktop_database
 
 %update_desktop_database_postun() {{ \
-if [ $1 = 0 ]; then \
-       umask 022; \
-       /usr/bin/update-desktop-database -q; \
-fi \
-}}
+if [ "$1" = "0" ]; then \
+       %update_desktop_database; \
+fi; \
+}}%{nil}
 
 #-----------------------------------------------------------------
 # Update shared MIME info database
@@ -480,7 +526,7 @@ fi \
 %update_mime_database() {{ \
        umask 022; \
        /usr/bin/update-mime-database %{_datadir}/mime; \
-}}
+}}%{nil}
 
 #-----------------------------------------------------------------
 # Update icon cache
@@ -489,7 +535,7 @@ fi \
 %update_icon_cache() {{ \
        umask 022; \
        /usr/bin/gtk-update-icon-cache -qf %{_datadir}/icons/%1; \
-}}
+}}%{nil}
 
 #-----------------------------------------------------------------
 # Update scrollkeeper database
@@ -497,12 +543,12 @@ fi \
 #
 %scrollkeeper_update_post() \
        /usr/bin/scrollkeeper-update -q; \
-       %{nil}
+%{nil}
 
 %scrollkeeper_update_postun() \
-if [ $1 = 0 ]; then \
+if [ "$1" = "0" ]; then \
        /usr/bin/scrollkeeper-update -q; \
-fi \
+fi; \
 %{nil}
 
 #-----------------------------------------------------------------
@@ -521,14 +567,15 @@ fi \
 %__noautoreq           %(sed -e s'/#.*//' /etc/rpm/noautoreq)%{?_noautoreq: %{_noautoreq}}
 %__noautoreqdep                %(sed -e s'/#.*//' /etc/rpm/noautoreqdep)%{?_noautoreqdep: %{_noautoreqdep}}
 %__noautoprov          %(sed -e s'/#.*//' /etc/rpm/noautoprov)%{?_noautoprov: %{_noautoprov}}
+
 #%_noautocompressdoc   %{nil}
 #
 %_missing_doc_files_terminate_build    1%{nil}
 %_unpackaged_files_terminate_build     %{nil}
 # (X)emacs support
 %___emacs_lispdir_helper  -batch -q -eval '(while load-path (princ (concat (car load-path) "\\n")) (setq load-path (cdr load-path)))' 2> /dev/null|sed -n '/\\(.*\\/x\\?emacs\\/site-lisp\\)\\/\\?$/{s,,\\1,p;q;}'
-%_emacs_lispdir %(emacs %___emacs_lispdir_helper)
-%_xemacs_lispdir %(xemacs %___emacs_lispdir_helper)
+%_emacs_lispdir %{expand:%%global _emacs_lispdir %(Z=$(emacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_emacs_lispdir
+%_xemacs_lispdir %{expand:%%global _xemacs_lispdir %(Z=$(xemacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_xemacs_lispdir
 
 %__php_provides        %{nil}
 %__php_requires %{nil}
@@ -538,37 +585,39 @@ fi \
 %__mono_requires %{nil}
 
 # Perl specific macro definitions.
-%perl_privlib          %(eval "`%{__perl} -V:installprivlib`"; echo $installprivlib)
-%perl_archlib          %(eval "`%{__perl} -V:installarchlib`"; echo $installarchlib)
-%perl_vendorlib                %(eval "`%{__perl} -V:installvendorlib`"; echo $installvendorlib)
-%perl_vendorarch       %(eval "`%{__perl} -V:installvendorarch`"; echo $installvendorarch)
-%perl_sitelib          %(eval "`%{__perl} -V:installsitelib`"; echo $installsitelib)
-%perl_sitearch         %(eval "`%{__perl} -V:installsitearch`"; echo $installsitearch)
+%perl_privlib          %{expand:%%global perl_privlib %(eval $(%{__perl} -V:installprivlib 2>/dev/null); echo ${installprivlib:-ERROR})}%perl_privlib
+%perl_archlib          %{expand:%%global perl_archlib %(eval $(%{__perl} -V:installarchlib 2>/dev/null); echo ${installarchlib:-ERROR})}%perl_archlib
+%perl_vendorlib                %{expand:%%global perl_vendorlib %(eval $(%{__perl} -V:installvendorlib 2>/dev/null); echo ${installvendorlib:-ERROR})}%perl_vendorlib
+%perl_vendorarch       %{expand:%%global perl_vendorarch %(eval $(%{__perl} -V:installvendorarch 2>/dev/null); echo ${installvendorarch:-ERROR})}%perl_vendorarch
+%perl_sitelib          %{expand:%%global perl_sitelib %(eval $(%{__perl} -V:installsitelib 2>/dev/null); echo ${installsitelib:-ERROR})}%perl_sitelib
+%perl_sitearch         %{expand:%%global perl_sitearch %(eval $(%{__perl} -V:installsitearch 2>/dev/null); echo ${installsitearch:-ERROR})}%perl_sitearch
 
 # Ruby
-%ruby_archdir          %(ruby -r rbconfig -e 'print Config::CONFIG["archdir"]' 2>/dev/null || echo ERROR)
-%ruby_ridir                    %(ruby -r rbconfig -e 'include Config; print File.join(CONFIG["datadir"], "ri", CONFIG["ruby_version"], "system")' 2>/dev/null || echo ERROR)
-%ruby_rubylibdir       %(ruby -r rbconfig -e 'print Config::CONFIG["rubylibdir"]' 2>/dev/null || echo ERROR)
-%ruby_sitearchdir      %(ruby -r rbconfig -e 'print Config::CONFIG["sitearchdir"]' 2>/dev/null || echo ERROR)
-%ruby_sitelibdir       %(ruby -r rbconfig -e 'print Config::CONFIG["sitelibdir"]' 2>/dev/null || echo ERROR)
-%ruby_version          %(ruby -r rbconfig -e 'print Config::CONFIG["ruby_version"]' 2>/dev/null || echo ERROR)
+%__ruby                                /usr/bin/ruby
+%ruby_archdir          %{expand:%%global ruby_archdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["archdir"]' 2>/dev/null || echo ERROR)}%ruby_archdir
+%ruby_ridir                    %{expand:%%global ruby_ridir %(%{__ruby} -r rbconfig -e 'include Config; print File.join(CONFIG["datadir"], "ri", CONFIG["ruby_version"], "system")' 2>/dev/null || echo ERROR)}%ruby_ridir
+%ruby_rubylibdir       %{expand:%%global ruby_rubylibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["rubylibdir"]' 2>/dev/null || echo ERROR)}%ruby_rubylibdir
+%ruby_vendorarchdir    %{expand:%%global ruby_vendorarchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorarchdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorarchdir
+%ruby_vendorlibdir     %{expand:%%global ruby_vendorlibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorlibdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorlibdir
+%ruby_sitearchdir      %{expand:%%global ruby_sitearchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitearchdir"]' 2>/dev/null || echo ERROR)}%ruby_sitearchdir
+%ruby_sitelibdir       %{expand:%%global ruby_sitelibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitelibdir"]' 2>/dev/null || echo ERROR)}%ruby_sitelibdir
+%ruby_version          %{expand:%%global ruby_version %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["ruby_version"]' 2>/dev/null || echo ERROR)}%ruby_version
 %ruby_ver_requires_eq  Requires:       ruby(ver) = %ruby_version
 %ruby_mod_ver_requires_eq      Requires:       ruby-modules(ver) = %ruby_version
 
 %php_pear_dir          /usr/share/pear
-%php_extensiondir      %(php-config --extension-dir 2>/dev/null || echo ERROR)
-%php_sysconfdir                %(php-config --sysconfdir 2>/dev/null || echo ERROR)
+%php_extensiondir      %{expand:%%global php_extensiondir %(php-config --extension-dir 2>/dev/null || echo ERROR)}%php_extensiondir
+%php_sysconfdir                %{expand:%%global php_sysconfdir %(php-config --sysconfdir 2>/dev/null || echo ERROR)}%php_sysconfdir
+%php_includedir                %{expand:%%global php_includedir %(php-config --include-dir 2>/dev/null || echo ERROR)}%php_includedir
 
-# directory where php includes are installed on system.
-%__php_includedir              /usr/include/php
 # extract php/zend api versions
-%php_major_version             %(awk '/#define PHP_MAJOR_VERSION/{print $3}' %{__php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)
-%php_api_version               %(awk '/#define PHP_API_VERSION/{print $3}' %{__php_includedir}/main/php.h 2>/dev/null || echo ERROR)
-%php_pdo_api_version   %(awk '/#define PDO_DRIVER_API/{print $3}' %{__php_includedir}/ext/pdo/php_pdo_driver.h 2>/dev/null || echo ERROR)
-%php_debug                             %(awk '/#define ZEND_DEBUG/{print $3}' %{__php_includedir}/main/php_config.h 2>/dev/null || echo ERROR)
-%zend_module_api               %(awk '/#define ZEND_MODULE_API_NO/{print $3}' %{__php_includedir}/Zend/zend_modules.h 2>/dev/null || echo ERROR)
-%zend_extension_api            %(awk '/#define ZEND_EXTENSION_API_NO/{print $3}' %{__php_includedir}/Zend/zend_extensions.h 2>/dev/null || echo ERROR)
-%zend_zts                              %(Z=$(grep -sc '^#define ZTS 1' %{__php_includedir}/main/php_config.h); echo ${Z:-ERROR})
+%php_major_version             %{expand:%%global php_major_version %(awk '/#define PHP_MAJOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)}%php_major_version
+%php_api_version               %{expand:%%global php_api_version %(awk '/#define PHP_API_VERSION/{print $3}' %{php_includedir}/main/php.h 2>/dev/null || echo ERROR)}%php_api_version
+%php_pdo_api_version   %{expand:%%global php_pdo_api_version %(awk '/#define PDO_DRIVER_API/{print $3}' %{php_includedir}/ext/pdo/php_pdo_driver.h 2>/dev/null || echo ERROR)}%php_pdo_api_version
+%php_debug                             %{expand:%%global php_debug %(awk '/#define ZEND_DEBUG/{print $3}' %{php_includedir}/main/php_config.h 2>/dev/null || echo ERROR)}%php_debug
+%zend_module_api               %{expand:%%global zend_module_api %(awk '/#define ZEND_MODULE_API_NO/{print $3}' %{php_includedir}/Zend/zend_modules.h 2>/dev/null || echo ERROR)}%zend_module_api
+%zend_extension_api            %{expand:%%global zend_extension_api %(awk '/#define ZEND_EXTENSION_API_NO/{print $3}' %{php_includedir}/Zend/zend_extensions.h 2>/dev/null || echo ERROR)}%zend_extension_api
+%zend_zts                              %{expand:%%global zend_zts %(Z=$(grep -sc '^#define ZTS 1' %{php_includedir}/main/php_config.h); echo ${Z:-ERROR})}%zend_zts
 
 # helper macro
 %__php_api_requires(v:) Requires: php%{-v*}(%{expand:%1}) = %{expand:%{%{!?2:%{1}}%{?2}}}
@@ -613,12 +662,31 @@ if [ -f /etc/rc.d/init.d/php-fcgi ]; then \
 fi \
 %{nil}
 
+
+# X.org helper macros
+%__xorg_abi_requires() Requires: xorg-xserver-server(%{expand:%1}-abi) = %{expand:%{%{!?2:%{1}}%{?2}}}
+#
+%xorg_xserver_ansic_abi                %{expand:%%global xorg_xserver_ansic_abi %(awk '/#define ABI_ANSIC_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_ansic_abi
+%xorg_xserver_extension_abi    %{expand:%%global xorg_xserver_extension_abi %(awk '/#define ABI_EXTENSION_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_extension_abi
+%xorg_xserver_font_abi         %{expand:%%global xorg_xserver_font_abi %(awk '/#define ABI_FONT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null | echo ERROR)}%xorg_xserver_font_abi
+%xorg_xserver_videodrv_abi     %{expand:%%global xorg_xserver_videodrv_abi %(awk '/#define ABI_VIDEODRV_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_videodrv_abi
+%xorg_xserver_xinput_abi       %{expand:%%global xorg_xserver_xinput_abi %(awk '/#define ABI_XINPUT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_xinput_abi
+
+%requires_xorg_xserver_extension %{__xorg_abi_requires ansic xorg_xserver_ansic_abi} \
+%{__xorg_abi_requires extension xorg_xserver_extension_abi}
+%requires_xorg_xserver_xinput %{__xorg_abi_requires ansic xorg_xserver_ansic_abi} \
+%{__xorg_abi_requires xinput xorg_xserver_xinput_abi}
+%requires_xorg_xserver_font %{__xorg_abi_requires ansic xorg_xserver_ansic_abi} \
+%{__xorg_abi_requires font xorg_xserver_font_abi}
+%requires_xorg_xserver_videodrv %{__xorg_abi_requires ansic xorg_xserver_ansic_abi} \
+%{__xorg_abi_requires videodrv xorg_xserver_videodrv_abi}
+
 # Python specific macro definitions.
 # python main version
-%py_ver                        %(python -c "import sys; print sys.version[:3]")
+%py_ver                        %{expand:%%global py_ver %(%{__python} -c "import sys; print sys.version[:3]" || echo ERROR)}%py_ver
 
 # directories
-%py_prefix             %(python -c "import sys; print sys.prefix")
+%py_prefix             %{expand:%%global py_prefix %(%{__python} -c "import sys; print sys.prefix" || echo ERROR)}%py_prefix
 %py_libdir             %{py_prefix}/%{_lib}/python%{py_ver}
 %py_scriptdir  %{py_prefix}/share/python%{py_ver}
 %py_incdir             /usr/include/python%{py_ver}
@@ -639,7 +707,7 @@ fi \
 %__spec_install_post_py_hardlink {\
 %{!?no_install_post_py_hardlink: __spec_install_post_py_hardlink() { \
 [ ! -d "$RPM_BUILD_ROOT" ] || find "$RPM_BUILD_ROOT" -name '*.pyc' | while read a; do \
-       b="$(echo $a|sed -e 's/.pyc$/.pyo/')"; \
+       b="${a%.pyc}.pyo"; \
        if cmp -s "$a" "$b"; then \
                ln -f "$a" "$b"; \
        fi; \
@@ -669,18 +737,18 @@ fi; \
 }
 
 # XMMS specific macros
-%xmms_prefix                   %(xmms-config --prefix 2>/dev/null)
-%xmms_exec_prefix              %(xmms-config --exec-prefix 2>/dev/null)
-%xmms_version                  %(xmms-config --version 2>/dev/null)
-%xmms_datadir                  %(xmms-config --data-dir 2>/dev/null)
-%xmms_plugindir                        %(xmms-config --plugin-dir 2>/dev/null)
-%xmms_visualization_plugindir  %(xmms-config --visualization-plugin-dir 2>/dev/null)
-%xmms_input_plugindir          %(xmms-config --input-plugin-dir 2>/dev/null)
-%xmms_output_plugindir         %(xmms-config --output-plugin-dir 2>/dev/null)
-%xmms_effect_plugindir         %(xmms-config --effect-plugin-dir 2>/dev/null)
-%xmms_general_plugindir                %(xmms-config --general-plugin-dir 2>/dev/null)
-
-%_target_base_arch     %(echo %{_target_cpu} | sed 's/i.86/i386/;s/athlon/i386/;s/pentium./i386/;s/amd64/x86_64/;s/ia32e/x86_64/')
+%xmms_prefix                   %{expand:%%global xmms_prefix %(xmms-config --prefix 2>/dev/null || echo ERROR)}%xmms_prefix
+%xmms_exec_prefix              %{expand:%%global xmms_exec_prefix %(xmms-config --exec-prefix 2>/dev/null || echo ERROR)}%xmms_exec_prefix
+%xmms_version                  %{expand:%%global xmms_version %(xmms-config --version 2>/dev/null || echo ERROR)}%xmms_version
+%xmms_datadir                  %{expand:%%global xmms_datadir %(xmms-config --data-dir 2>/dev/null || echo ERROR)}%xmms_datadir
+%xmms_plugindir                        %{expand:%%global xmms_plugindir %(xmms-config --plugin-dir 2>/dev/null || echo ERROR)}%xmms_plugindir
+%xmms_visualization_plugindir  %{expand:%%global xmms_visualization_plugindir %(xmms-config --visualization-plugin-dir 2>/dev/null || echo ERROR)}%xmms_visualization_plugindir
+%xmms_input_plugindir          %{expand:%%global xmms_input_plugindir %(xmms-config --input-plugin-dir 2>/dev/null || echo ERROR)}%xmms_input_plugindir
+%xmms_output_plugindir         %{expand:%%global xmms_output_plugindir %(xmms-config --output-plugin-dir 2>/dev/null || echo ERROR)}%xmms_output_plugindir
+%xmms_effect_plugindir         %{expand:%%global xmms_effect_plugindir %(xmms-config --effect-plugin-dir 2>/dev/null || echo ERROR)}%xmms_effect_plugindir
+%xmms_general_plugindir                %{expand:%%global xmms_general_plugindir %(xmms-config --general-plugin-dir 2>/dev/null || echo ERROR)}%xmms_general_plugindir
+
+%_target_base_arch     %{expand:%%global _target_base_arch %(echo %{_target_cpu} | sed 's/i.86/i386/;s/athlon/i386/;s/pentium./i386/;s/amd64/x86_64/;s/ia32e/x86_64/')}%_target_base_arch
 
 # user/group checking macros
 #
@@ -721,7 +789,12 @@ fi; \
 # -e   - send to stderr instead of stdout
 # -n   - no show banner (overrides -t)
 # -t   - show only, if RPM_SCRIPTVERBOSITY >= n; default n=5
-%banner(aent:) \
+#
+# Tests:
+# (rpm -E '%banner -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m
+# rpm -E 'date | %banner -e banner' > m; sh -x m
+#
+%banner(aent:) ( \
 RPM_SCRIPTVERBOSITY=5 \
 [ -r /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
 if [ -x /usr/bin/banner.sh ]; then \
@@ -729,11 +802,11 @@ if [ -x /usr/bin/banner.sh ]; then \
 else \
        CMD="cat%{-e: >&2}" \
 fi \
-eval $CMD %2%{?3: %3} \
-%nil
+eval $CMD %{?2:%2}%{?3: %3}) \
+%{nil}
 
 # useradd/groupadd macros
-# Author: Elan Ruusamäe <glen@pld-linux.org>
+# Author: Elan Ruusamäe <glen@pld-linux.org>
 #
 # Usage:
 #   %useradd [-P package] [-u uid] [-d home_dir] [-s shell] [-c comment]
@@ -796,77 +869,8 @@ else \
        [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i group || : \
 fi;
 
-# apache_config_{install/uninstall} macros *DEPRECATED*
-# Author: Elan Ruusamäe <glen@pld-linux.org>
-#
-# You should use webapp macros instead. these are here until single piece of
-# them is gone from specs ;)
-#
-# The config is installed/removed inside trigger, this means that you can any
-# time install apache1 or apache package and the configuration file is updated.
-# if you don't need the config for various reason for specific apache, just
-# remove the symlink from apache config directory. the trigger will not put the
-# config again to that version of apache. In other words the config is linked
-# to apache config directory on first install of PACKAGE or apache.
-#
-# should be called in trigger body:
-#  %triggerin -- apache1 >= 1.3.33-2
-#  %apache_config_install -v 1
-#
-# Add package's apache config to apache config.
-#
-# Usage:
-#   %apache_config_install -v {1|2} -c %{_sysconfdir}/apache-%{name}.conf -n 99
-#
-#  -v REQUIRED: specify apache version. can be 1 or 2.
-#  -c OPTIONAL: specify full path to PACKAGE's config. Defaults to %{_sysconfdir}/apache-%{name}.conf.
-#  -n OPTIONAL: specify config "slot". defaults to 99
-#  -f OPTIONAL: force symlink creation regardless if package was upraded. useful in triggers
-#
-# Internal macros. don't use ;).
-# expands apache config dir by apache version at build time.
-%__apache_confdir() %(if [ %{1} = 1 ]; then echo /etc/apache/conf.d; elif [ %{1} = 2 ]; then echo /etc/httpd/httpd.conf; else echo >&2 Unknown apache version specified; fi)
-# expands apache service name by apache version at build time.
-%__apache_svcname() %(if [ %{1} = 1 ]; then echo apache; elif [ %{1} = 2 ]; then echo httpd; else echo >&2 Unknown apache version specified; fi)
-
-%apache_config_install(fv:c:n:) \
-%{!-v:%{error:apache_config_install: Required argument -v missing}} \
-%{?debug:set -x; echo "apache_config_install:%{-v*} %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
-if [ -n "%{-f:1}" ] || ([ "$1" = "1" ] && [ "$2" = "1" ]) && [ -d %{__apache_confdir %{-v*}} ]; then\
-       ln -sf %{-c*}%{!-c:%{_sysconfdir}/apache-%{name}.conf} %{__apache_confdir %{-v*}}/%{-n*}%{!-n:99}_%{name}.conf\
-fi\
-# reload apache if the config symlink is there\
-if [ -L %{__apache_confdir %{-v*}}/%{-n*}%{!-n:99}_%{name}.conf ]; then\
-       # additionally don't reload if target package (the webserver) is upgraded, as webserver is restarted anyway in %post \
-       if [ "$2" != "2" ] && [ -f /var/lock/subsys/%{__apache_svcname %{-v*}} ]; then\
-               /etc/rc.d/init.d/%{__apache_svcname %{-v*}} reload 1>&2\
-       fi\
-fi\
-%{nil}
-
-# Remove package's apache config from apache config.
-#
-# Usage:
-#   %apache_config_uninstall -v {1|2} -n 99
-#
-#  -v REQUIRED: specify apache version. can be 1 or 2.
-#  -n OPTIONAL: specify config "slot". defaults to 99
-%apache_config_uninstall(v:n:) \
-%{!-v:%{error:apache_config_uninstall: Required argument -v missing}} \
-%{?debug:set -x; echo "apache_config_uninstall:%{-v*} %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
-# remove link if either of the packages are gone \
-if [ "$1" = "0" ] || [ "$2" = "0" ]; then \
-       if [ -L %{__apache_confdir %{-v*}}/%{-n*}%{!-n:99}_%{name}.conf ]; then \
-               rm -f %{__apache_confdir %{-v*}}/%{-n*}%{!-n:99}_%{name}.conf \
-               if [ -f /var/lock/subsys/%{__apache_svcname %{-v*}} ]; then \
-                       /etc/rc.d/init.d/%{__apache_svcname %{-v*}} reload 1>&2 \
-               fi \
-       fi \
-fi \
-%{nil}
-
 # webapp macros
-# Author: Elan Ruusamäe <glen@pld-linux.org>
+# Author: Elan Ruusamäe <glen@pld-linux.org>
 #
 # The config is installed/removed inside trigger, this means that you can any
 # time install apache1/apache/lighttpd package and the configuration file is
@@ -903,34 +907,8 @@ if [ -n "%{-f:1}" ] || [ "$1" = "0" ] || [ "$2" = "0" ] && [ -L /etc/%1/webapps.
 fi \
 %{nil}
 
-# see browser-plugins.spec / template-browser-plugin.spec
-# Author: Elan Ruusamäe <glen@pld-linux.org>
-%nsplugin_install(d:f) { \
-# create link if it's first install of either of the packages \
-if [ -n "%{-f:1}" ] || ([ "$1" = "1" ] && [ "$2" = "1" ] && [ -d %{-d*} ]); then \
-( \
-%( \
-       for file in %{*}; do \
-               echo echo Installing $file to %{-d*}; \
-               echo "ln -sf %{_libdir}/browser-plugins/$file %{-d*};"; \
-       done ) \
-) | ( %banner -t 5 -e %{name}-in ); fi; \
-}
-
-%nsplugin_uninstall(d:) { \
-# remove link if either of the packages are gone \
-if [ "$1" = "0" ] || [ "$2" = "0" ]; then \
-( \
-%( \
-       for file in %{*}; do \
-               echo echo Removing $file from %{-d*}; \
-               echo "rm -f %{-d*}/$file;"; \
-       done ) \
-) | ( %banner -t 5 -e %{name}-un ); fi; \
-}
-
 # service macro.
-# Author: Elan Ruusamäe <glen@pld-linux.org>
+# Author: Elan Ruusamäe <glen@pld-linux.org>
 #
 # calls usual service restart on package %post, but skips the restart if
 # administrator has disabled automatic service restarts in either global
@@ -944,23 +922,43 @@ if [ "$1" = "0" ] || [ "$2" = "0" ]; then \
 %service(q) {{%(export quiet=%{-q:1}; /usr/lib/rpm/service_generator.sh %{*}) };}
 
 
-# java macros. based on jpackage macros.java
+# Java macros. based on jpackage macros.java
+#
+# Root directory where all Java VMs/SDK/JREs are installed.
 %_jvmdir               %{_libdir}/jvm
+
+# Root directory where all Java VMs/SDK/JREs expose their jars
 %_jvmjardir            %{_libdir}/jvm-exports
-%_jvmprivdir           %{_libdir}/jvm-private
+
+# Root directory for all Java VM/SDK/JRE's private things.
+%_jvmprivdir   %{_libdir}/jvm-private
+
+# Root directory for all architecture dependent parts of Java VM/SDK/JRE's
 %_jvmlibdir            %{_libdir}/jvm
-%_jvmdatadir           %{_datadir}/jvm
-%_jvmsysconfdir                %{_sysconfdir}/jvm
-# FIXME: are these used?
+
+# Root directory for all architecture independent parts of Java VM/SDK/JRE's
+%_jvmdatadir   %{_datadir}/jvm
+
+# Root directory for all configurations parts of Java VM/SDK/JRE's
+%_jvmsysconfdir        %{_sysconfdir}/jvm
+
+# Root directory for all common architecture dependent parts of Java VM/SDK/JRE's
 %_jvmcommonlibdir      %{_libdir}/jvm-common
+
+# Root directory for all common architecture independent parts of Java VM/SDK/JRE's
 %_jvmcommondatadir     %{_datadir}/jvm-common
+
+# Root directory for all common configurations parts of Java VM/SDK/JRE's
 %_jvmcommonsysconfdir  %{_sysconfdir}/jvm-common
+
+# Directory where arch-specific (JNI) version-independent jars are installed.
 %_jnidir               %{_libdir}/java
-%java_home             %(unset JAVA_HOME; . %{_javadir}-utils/java-functions; set_jvm; echo $JAVA_HOME)
+
+%java_home             %{expand:%%global java_home %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVA_HOME; . %{_javadir}-utils/java-functions; set_jvm; echo ${JAVA_HOME:-ERROR})}%java_home
 
 %ant                   JAVA_HOME=%{java_home} ant
 %jar                   %{java_home}/bin/jar
-%java                  %(unset JAVACMD; . %{_javadir}-utils/java-functions; set_javacmd; echo $JAVACMD)
+%java                  %{expand:%%global java %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVACMD; . %{_javadir}-utils/java-functions; set_javacmd; echo $JAVACMD)}%java
 %javac                 %{java_home}/bin/javac
 %javadoc               %{java_home}/bin/javadoc
 
@@ -1003,8 +1001,55 @@ set_options $BASE_OPTIONS\
 run "$@"\
 EOF
 
+# jpackage 1.7
+# Directory for maven depmaps
+#
+%_mavendepmapdir /etc/maven
+%_mavendepmapfragdir /etc/maven/fragments
+
+#
+# add_to_depmap adds an entry to the depmap. The arguments are:
+#
+# %1 the original groupid
+# %2 the original artifact id
+# %3 the version
+# %4 the new groupid
+# %5 the new artifactid
+#
+
+%add_to_maven_depmap() \
+install -dm 755 $RPM_BUILD_ROOT/%{_mavendepmapfragdir}\
+cat >>$RPM_BUILD_ROOT/%{_mavendepmapfragdir}/%{name}<< EOF\
+<dependency>\
+    <maven>\
+        <groupId>%1</groupId>\
+        <artifactId>%2</artifactId>\
+        <version>%3</version>\
+    </maven>\
+    <jpp>\
+        <groupId>%4</groupId>\
+        <artifactId>%5</artifactId>\
+        <version>%3</version>\
+    </jpp>\
+</dependency>\
+\
+EOF\
+%{nil}
+
+#==============================================================================
+#
+# update_maven_depmap updates the main maven depmap
+#
+%update_maven_depmap() \
+echo -e "<dependencies>\\n" > %{_mavendepmapdir}/maven2-depmap.xml\
+if [ -d %{_mavendepmapfragdir} ] && [ -n "`find %{_mavendepmapfragdir} -type f`" ]; then\
+cat %{_mavendepmapfragdir}/* >> %{_mavendepmapdir}/maven2-depmap.xml\
+fi\
+echo -e "</dependencies>\\n" >> %{_mavendepmapdir}/maven2-depmap.xml
+
+
 # PEAR install macros
-# Author: Elan Ruusamäe <glen@pld-linux.org>
+# Author: Elan Ruusamäe <glen@pld-linux.org>
 #
 # Usage:
 #      %%pear_package_setup [-a #] [-n FMT]
@@ -1044,16 +1089,7 @@ fi \
 # command invoking pear cli
 %__pear /usr/bin/pear
 
-# the main macro.
-# using this macro will append optional-packages.txt to the nocompressdoc list
-# as it's displayed to user after package install. and adding additional gzip
-# dep is just waste ;)
-%pear_package_setup(a:n:z) \
-%define srcdir %{-n*}%{!-n:%{_pearname}-%{version}} \
-%define builddir %{_builddir}/%{srcdir} \
-%setup -q -c -T -n %{srcdir} \
-%{-z:tar zxf %{S:0}; %{-a:tar zxf %{S:%{-a*}}}} \
-%{-z:_P=package2.xml; [ -f $_P ] || _P=package.xml; _N=%{srcdir}; mv $_P $_N; cd $_N} \
+%pear_install(a:n:zD) \
 %__pear \\\
        -c pearrc \\\
        -d doc_dir=/docs \\\
@@ -1066,19 +1102,31 @@ fi \
        --offline \\\
        --nodeps \\\
        %{-f:--force} \\\
-       %{!-z:%{S:%{-a*}%{!-a:0}}}%{-z:$_P} > .install.log || { c=$?; cat .install.log; exit $c; } \
+       %{!-z:%{S:%{-a*}%{!-a:0}}}%{-z:$_P} > .install.log || { c=$?; cat .install.log; exit $c; }; \
+%{nil}
+
+# The main macro.
+# using this macro will append optional-packages.txt to the nocompressdoc list
+# as it's displayed to user after package install. and adding additional gzip
+# dep is just waste ;)
+%pear_package_setup(a:n:zD) \
+%define srcdir %{-n*}%{!-n:%{_pearname}-%{version}} \
+%define builddir %{_builddir}/%{srcdir} \
+%setup -q -c -T %{-D:-D} -n %{srcdir} \
+%{-z:tar zxf %{S:0}; %{-a:tar zxf %{S:%{-a*}}}} \
+%{-z:_P=package2.xml; [ -f $_P ] || _P=package.xml; _N=%{srcdir}; mv $_P $_N; cd $_N} \
+%pear_install \
 %{-z:cd ..} \
 cat %{-z:$_N/}.install.log | %__pear_install_log \
 \
 # undos sources \
-find -type f -print0 | xargs -0 sed -i -e 's,\\r$,,' \
+find -type f -print0 | xargs -0 sed -i -e 's,\\r$,,' \
 %{!?_noautocompressdoc:%global _noautocompressdoc %{nil}}%{expand:%%global _noautocompressdoc %{_noautocompressdoc} optional-packages.txt} \
 %{!?_noautoprov:%global _noautoprov %{nil}}%{expand:%%global _noautoprov %{_noautoprov} 'pear(tests/.*)'} \
 %{nil}
 
-# copies exctracted PEAR package structure to buildroot.
-# also copies PEAR registry file.
-# please use this macro, for future extensions being possible.
+# Copies exctracted PEAR package structure and PEAR registry to buildroot.
+# Author: Elan Ruusamäe <glen@pld-linux.org>
 %pear_package_install() \
 cp -a ./%{php_pear_dir}/{.registry,*} $RPM_BUILD_ROOT%{php_pear_dir} \
 find $RPM_BUILD_ROOT%{php_pear_dir} '(' -name '*~' -o -name '*.orig' ')' | xargs -r rm -v \
@@ -1091,7 +1139,7 @@ fi \
 
 
 # Register OpenLDAP schema.
-# Author: Elan Ruusamäe <glen@pld-linux.org>
+# Author: Elan Ruusamäe <glen@pld-linux.org>
 #
 # Usage:
 #   %%openldap_schema_register [-d core,nis] %{schemadir}/horde.schema
@@ -1118,7 +1166,7 @@ fi \
 %{nil}
 
 # Unregister OpenLDAP schema.
-# Author: Elan Ruusamäe <glen@pld-linux.org>
+# Author: Elan Ruusamäe <glen@pld-linux.org>
 #
 # Usage:
 #   %%openldap_schema_unregister %{schemadir}/horde.schema
@@ -1163,7 +1211,7 @@ done \
 # Developer note: don't touch it unless you know how to handle '\'.
 # - \ in script expands to nothing
 # - \\\ in script expands to \
-# - \\\ inside definition expands to noting
+# - \\\ inside definition expands to nothing
 # - \\\\\\\ inside definition expands to \
 # - in last line \ has to touch arguments so arguments passing
 #   in new lines (using \) will be supported
@@ -1174,22 +1222,23 @@ done \
 %define Opts                                                                                                           \\\\\\\
 %if "%{_target_base_arch}" != "%{_arch}"                                                       \\\
        %if "%{_arch}" == "x86_64" && "%{_target_base_arch}" == "i386"  \\\
-       CC="%{__cc}" CPP="%{__cpp}" ARCH=%{_target_base_arch}                   \\\
+       CC="%{kgcc}" ARCH=%{_target_base_arch}                                                  \\\
        %else                                                                                                                   \\\
        ARCH=%{_target_base_arch} CROSS_COMPILE=%{_target_cpu}-pld-linux- \\\
        %endif                                                                                                                  \\\
 %else                                                                                                                          \\\
-       CC="%{__cc}" CPP="%{__cpp}"                                                                             \\\
+       CC="%{kgcc}"                                                                                                    \\\
 %endif                                                                                                                         \
-%define        MakeOpts HOSTCC="%{__cc}" SYSSRC=%{_kernelsrcdir} SYSOUT=$PWD/o \\\\\\\
+%define        MakeOpts HOSTCC="%{kgcc}" SYSSRC=%{_kernelsrcdir} SYSOUT=$PWD/o \\\\\\\
                O=$PWD/o %{?with_verbose:V=1} %{Opts}                                           \
                                                                                                                                        \
 %{?-C:cd %{-C*}}                                                                                                       \
 compile() {                                                                                                                    \
        L="<"; [[ '%{*}' != *$L$L* ]] || PATCH_SH="set -x -e;$(cat)"    \
        set -e -x                                                                                                               \
+       local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
                                                                                                                                        \
-for cfg in %{?with_dist_kernel:%{?with_smp:smp} up}%{!?with_dist_kernel:nondist}; do \
+for cfg in ${cfgs:-dist}; do                                        \
        [ -r "%{_kernelsrcdir}/config-$cfg" ] || exit 1                                 \
                                                                                                                                        \
        rm -rf o                                                                                                                \
@@ -1197,13 +1246,6 @@ for cfg in %{?with_dist_kernel:%{?with_smp:smp} up}%{!?with_dist_kernel:nondist}
        ln -sf %{_kernelsrcdir}/config-$cfg o/.config                                   \
        ln -sf %{_kernelsrcdir}/Module.symvers-$cfg o/Module.symvers    \
        ln -sf %{_kernelsrcdir}/include/linux/autoconf-$cfg.h o/include/linux/autoconf.h \
-%ifarch ppc ppc64                                                                                                      \
-       install -d o/include/asm                                                                                \
-       [ ! -d %{_kernelsrcdir}/include/asm-powerpc ] || ln -sf %{_kernelsrcdir}/include/asm-powerpc/* o/include/asm    \
-       [ ! -d %{_kernelsrcdir}/include/asm-%{_target_base_arch} ] || ln -snf %{_kernelsrcdir}/include/asm-%{_target_base_arch}/* o/include/asm \
-%else                                                                                                                          \
-       ln -sf %{_kernelsrcdir}/include/asm-%{_target_base_arch} o/include/asm \
-%endif                                                                                                                         \
                                                                                                                                        \
        set +x                                                                                                                  \
        [ -z "$PATCH_SH" ] || echo "$PATCH_SH" | %__spec_build_shell    \
@@ -1221,7 +1263,9 @@ for cfg in %{?with_dist_kernel:%{?with_smp:smp} up}%{!?with_dist_kernel:nondist}
                                                                                                                                        \
        %{!?-c:%{__make} -C %{_kernelsrcdir} clean                                              \\\
                RCS_FIND_IGNORE="-name '*.ko' -o"                                                       \\\
+               ${1+"$@"}                                                                                                       \\\
                M=$PWD %{MakeOpts}}                                                                                     \
+                                                                                                                                       \
        %{__make} -C %{_kernelsrcdir} modules                                                   \\\
                ${1+"$@"}                                                                                                       \\\
                M=$PWD %{MakeOpts}                                                                                      \
@@ -1250,7 +1294,7 @@ compile %{*}\
 #  -s <suffix> -- suffix to use when installing modules, useful when module
 #              with same name exists in kernel already
 #  -n <file> -- name of modprobe config file to use (without .conf extension)
-#              for definig aliases, only useful with -s
+#              for defining aliases, only useful with -s
 
 %install_kernel_modules(m:d:s:n:)                                                                      \
 %{!?-m:%{error:%{0}: Required module name (-m) missing}exit 1}         \
@@ -1260,27 +1304,24 @@ compile %{*}\
 %define KernelD $RPM_BUILD_ROOT/lib/modules/%{_kernel_ver}                     \
 %define ModprobeD $RPM_BUILD_ROOT%{_sysconfdir}/modprobe.d/%{_kernel_ver} \
                                                                                                                                        \
-install -d %{KernelD}{,smp}/%{-d*}                                                                     \
-%{?-s:install -d %{ModprobeD}{,smp}}                                                           \
+local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
                                                                                                                                        \
 for MODULE in {%{-m*},}; do                                                                                    \
        [ -n "${MODULE}" ] || continue                                                                  \
-       MNAME=${MODULE##*/}                                                                                             \
-       install ${MODULE}-%{?with_dist_kernel:up}%{!?with_dist_kernel:nondist}.ko \\\
-               %{KernelD}/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko                                      \
-       %{?-s:echo "alias ${MNAME} ${MNAME}-%{-s*}"                                             \\\
-               >> %{ModprobeD}/%{-n*}.conf}                                                            \
-    %if %{with smp} && %{with dist_kernel}                                                     \
-       install ${MODULE}-smp.ko                                                                                \\\
-               %{KernelD}smp/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko                           \
-       %{?-s:echo "alias ${MNAME} ${MNAME}-%{-s*}"                                             \\\
-               >> %{ModprobeD}smp/%{-n*}.conf}                                                         \
-    %endif                                                                                                                     \
+       for cfg in ${cfgs:-dist}; do                                    \
+               [ "$cfg" = smp ] && suf=smp || suf=                                                     \
+               MNAME=${MODULE##*/}                                                                                     \
+               install -D ${MODULE}-$cfg.ko                                                            \\\
+                       %{KernelD}$suf/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko                  \
+               %{?-s:install -d %{ModprobeD}$suf                                                       \
+                       echo "alias ${MNAME} ${MNAME}-%{-s*}"                                   \\\
+                       >> %{ModprobeD}$suf/%{-n*}.conf}                                                \
+       done                                                                                                                    \
 done                                                                                                                           \
 %{nil}
 
 # patchset macros
-# Author: Elan Ruusamäe <glen@pld-linux.org>
+# Author: Elan Ruusamäe <glen@pld-linux.org>
 #
 # Usage:
 #   %patchset_source -f <seq(1) format> <start> [<end>]
@@ -1320,4 +1361,83 @@ done                                                                                                                             \
 ) \
 %{nil}
 
+# browser plugins v2
+# Author: Elan Ruusamäe <glen@pld-linux.org>
+#
+# Usage:
+#      %browser_plugins_add_browser <name> -p <plugindir>
+#
+#  <name> (required) -- name of the browser. usually %{name}.
+#  -p <plugindir> (required) -- in what directory browser searches for its plugins.
+#  -b -- default blacklists
+#  -a <arch> override arch
+#
+# Example:
+#   %browser_plugins_add_browser %{name} -p %{_firefoxdir}/plugins
+
+%_browserpluginsconfdir                /etc/browser-plugins
+%_browserpluginsdir                    %{_libdir}/browser-plugins
+%update_browser_plugins                /usr/sbin/update-browser-plugins || :
+
+%browser_plugins_add_browser(p:b:a:) \
+       browser=%1.%{!-a:%{_target_base_arch}}%{-a*} \
+       install -d $RPM_BUILD_ROOT%{_browserpluginsconfdir}/{blacklist,browsers}.d \
+       ln -s %{-p*} $RPM_BUILD_ROOT%{_browserpluginsconfdir}/browsers.d/$browser \
+       blacklist_file=$RPM_BUILD_ROOT%{_browserpluginsconfdir}/blacklist.d/$browser.blacklist \
+       echo '# This file format is shell globs at base dir of plugindir' > $blacklist_file \
+       %{-b:cat >> $blacklist_file %{-b*}} \
+%{nil}
+
+# Helper for LUA.
+# split string separated by space into quoted list
+#
+# Author: Elan Ruusamäe <glen@pld-linux.org>
+#
+# %__lua_split /bin/sh /bin/pdksh -> "/bin/sh", "/bin/pdksh"
+%__lua_split() %(echo "%*" | awk '{for (i=1;i<=NF;i++) printf("\\"%%s\\"%%s", $i, i == NF ? "" : ", ")}')
+
+# adjust /etc/shells by adding and removing shells from there
+# Author: Elan Ruusamäe <glen@pld-linux.org>
+#
+# Usage:
+#   %post      -p %add_etc_shells -p /bin/sh /bin/pdksh
+#   %preun     -p %remove_etc_shells -p /bin/sh /bin/pdksh
+#
+#  -p (optional) -- specifies that result is embeded %post script (prepends <lua> as first line)
+
+%add_etc_shells(p) %{-p:<lua>}\
+t = {}\
+f = io.open("/etc/shells", "r")\
+if f then\
+       for l in f:lines() do t[l]=l; end\
+       f:close()\
+end\
+for _, s in ipairs({%{expand:%%__lua_split %*}}) do\
+       if not t[s] then\
+               print("Adding "..s.." to /etc/shells")\
+               f = io.open("/etc/shells", "a"); f:write(s.."\\n"); f:close()\
+       end\
+end\
+%{nil}
+
+%remove_etc_shells(p) %{-p:<lua>}\
+%{-p:if arg[2] == 0 then}\
+       t = {}\
+       f = io.open("/etc/shells", "r")\
+       if f then\
+               for l in f:lines() do t[l]=l; end\
+               f:close()\
+       end\
+       for _, l in pairs({%{expand:%%__lua_split %*}}) do\
+               print("Removing "..l.." from /etc/shells")\
+               t[l] = nil\
+       end\
+       s=""\
+       for _, l in pairs(t) do\
+               s=s..l.."\\n"\
+       end\
+       io.open("/etc/shells", "w"):write(s)\
+%{-p:end} \
+%{nil}
+
 # vim:ts=4 sw=4 noet syn=spec
This page took 0.089024 seconds and 4 git commands to generate.